package com.example.zego_zpns.internal;

import android.content.Context;
import android.os.Handler;
import android.os.Looper;
import java.util.HashMap;

import im.zego.zpns.ZPNsMessageReceiver;
import im.zego.zpns.entity.ZPNsMessage;
import im.zego.zpns.entity.ZPNsRegisterMessage;

import io.flutter.plugin.common.EventChannel;

public class ZPNsPluginEventHandler extends ZPNsMessageReceiver {
    
    public static EventChannel.EventSink mySink = null;

    public void setSink(EventChannel.EventSink sink){
        mySink = sink;
    }


    @Override
    protected void onThroughMessageReceived(Context context, ZPNsMessage message) {
        if(mySink == null){
            return;
        }
        HashMap<String,Object> resultMap = new HashMap<>();
        resultMap.put("method","onThroughMessageReceived");
        resultMap.put("message",ZPNsConverter.cnvZPNsMessageObjectToMap(message));

        Handler handler = new Handler(Looper.getMainLooper());
        handler.post(() -> mySink.success(resultMap));
    }

    @Override
    protected void onNotificationClicked(Context context, ZPNsMessage message) {
        if(mySink == null){
            return;
        }
        HashMap<String,Object> resultMap = new HashMap<>();
        resultMap.put("method","onNotificationClicked");
        resultMap.put("message",ZPNsConverter.cnvZPNsMessageObjectToMap(message));

        Handler handler = new Handler(Looper.getMainLooper());
        handler.post(() -> mySink.success(resultMap));
    }

    @Override
    protected void onNotificationArrived(Context context, ZPNsMessage message) {
        if(mySink == null){
            return;
        }
        HashMap<String,Object> resultMap = new HashMap<>();
        resultMap.put("message",ZPNsConverter.cnvZPNsMessageObjectToMap(message));
        resultMap.put("method","onNotificationArrived");

        Handler handler = new Handler(Looper.getMainLooper());
        handler.post(() -> mySink.success(resultMap));
    }

    @Override
    protected void onRegistered(Context context, ZPNsRegisterMessage message) {
        if(mySink == null){
            return;
        }
        HashMap<String,Object> resultMap = new HashMap<>();

        resultMap.put("method","onRegistered");

        resultMap.put("message",ZPNsConverter.cnvZPNsRegisterMessageObjectToMap(message));
        Handler handler = new Handler(Looper.getMainLooper());
        handler.post(() -> mySink.success(resultMap));

    }
}
