import 'dart:io';

import 'package:flutter/services.dart';
import 'package:zego_zpns/src/internal/zpns_converter.dart';
import 'package:zego_zpns/src/internal/zpns_engine.dart';
import 'zpns_settings.dart';
import '../../zego_zpns.dart';

class ZPNsManager {
  static ZPNsEngine? instanceEngine;

  static ZPNsEngine getInstance() {
    instanceEngine ??= ZPNsEngine();
    return instanceEngine!;
  }

  static Future<String> getVersion() async {
    return await ZPNsSettings.channel.invokeMethod("getVersion");
  }

  static enableDebug(bool debug) {
    if (Platform.isAndroid) {
      ZPNsSettings.channel.invokeMethod('enableDebug', {'debug': debug});
    }
  }

  static setPushConfig(ZPNsConfig config) async {
    ZPNsSettings.channel.invokeMethod('setPushConfig',
        {'config': ZPNsConverter.cnvZPNsConfigObjectToMap(config)});
  }
}
